#!/bin/csh
# usage : make.ms start_slice slice_step total_slices
#                 d.tbl i.tbl e.tbl dr r0/dr t0
#                 {f0 df} BPS directory
#
if ($#argv != 11 && $#argv != 13) then
  stderr  usage : make.ms start_slice slice_step total_slices
  stderr '                d.tbl i.tbl e.tbl dr r0/dr t0'
  stderr '                {f0 df} BPS directory'
  exit 1
endif
#
set dtbl=$argv[4]
if (!(-f $dtbl)) then
  stderr $dtbl : file not found. ; exit 1
endif
set dark=`cut -d'#' -f1 $dtbl | awk 'NF>0 { print $1 }' | tail -1`
if (!(-f $dark)) then
  stderr $dark : file not found. ; exit 1
endif
#
set awk=('NR==1 { limit=$2;' \
                 'fmt=sprintf("%%0%dd\n",length(sprintf("%d",limit-1))) }' \
         'NR==2 { for (idx=0; idx<$3; idx++) {' \
                   'slice=$1+$2*idx;' \
                   'if (slice>=0 && slice<limit) printf fmt,slice }}')
foreach slice (`( hp2wl $dark ; echo $argv[1-3] ) | awk "$awk"`)
  echo -n "$slice " | tr ' ' '\011'
  hp2p $slice $argv[4-6] - | p2tiff - ${argv[7-]}/${slice}.tif
end
