#!/bin/csh
# usage : make.ss r0/dr_gradient_per_slice r0/dr_for_slice_0
#                 start_slice slice_step total_slices
#                 d.tbl i.tbl e.tbl dr t0
#                 {f0 df} BPS directory
#
if ($#argv != 12 && $#argv != 14) then
  stderr 'usage : make.ss r0/dr_gradient_per_slice r0/dr_for_slice_0'
  stderr '                start_slice slice_step total_slices'
  stderr '                d.tbl i.tbl e.tbl dr t0'
  stderr '                {f0 df} BPS directory'
  exit 1
endif
#
set dtbl=$argv[6]
if (!(-f $dtbl)) then
  stderr $dtbl : file not found. ; exit 1
endif
set dark=`cut -d'#' -f1 $dtbl | awk 'NF>0 { print $1 }' | tail -1`
if (!(-f $dark)) then
  stderr $dark : file not found. ; exit 1
endif
#
set awk=('NR==1 { limit=$2;' \
                 'fmt=sprintf("%%0%dd\n",length(sprintf("%d",limit-1))) }' \
         'NR==2 { for (idx=0; idx<$3; idx++) {' \
                   'slice=$1+$2*idx;' \
                   'if (slice>=0 && slice<limit) printf fmt,slice }}')
foreach slice (`( hp2wl $dark ; echo $argv[3-5] ) | awk "$awk"`)
  set r0dr=`echo $slice $argv[1-2] | awk '{ printf "%f\n",$1*$2+$3 }'`
  echo -n "$slice $r0dr " | tr ' ' '\011'
  hp2p $slice $argv[6-8] - | p2tiff - $argv[9] $r0dr ${argv[10-]}/${slice}.tif
end
