#!/bin/csh
# usage : make.ts r0/dr_start r0/dr_step total_r0/dr's
#                 slice d.tbl i.tbl e.tbl dr t0
#                 BPS directory
#
set tmp=/tmp/make.ts.$$
#
if ($#argv != 11) then
  stderr "usage : make.ts r0/dr_start r0/dr_step total_r0/dr's"
  stderr '                slice d.tbl i.tbl e.tbl dr t0'
  stderr '                BPS directory'
  exit 1
endif
#
hp2p $argv[4-7] $tmp ; if ($status != 0) exit 1
#
set awk=('{ limit=0;' \
           'for (idx=0; idx<$3; idx++) {' \
             'r0dr=$1+$2*idx;' \
             'mr0dr[idx]=sprintf("%g",-r0dr);' \
             'dot[idx]=index(mr0dr[idx],".");' \
             'if (dot[idx]==0) dot[idx]=length(mr0dr[idx])+1;' \
             'if (dot[idx]>limit) limit=dot[idx] }' \
           'for (idx=0; idx<$3; idx++) {' \
             'printf "-";' \
             'for (ptr=dot[idx]; ptr<limit; ptr++) printf "0";' \
             'printf "%s\n",mr0dr[idx] }}')
foreach r0dr (`echo $argv[1-3] | awk "$awk"`)
  echo -n "$argv[4] $r0dr " | tr ' ' '\011'
  p2tiff $tmp $argv[8] $r0dr ${argv[9-]}/`echo $r0dr | tr -d - | tr . _`.tif
end
rm $tmp
