
#ifndef	Float
#define Float	double
#endif

#ifndef Filter
#define Filter	Shepp
#else
extern double	Filter();
#endif

#ifndef	M_PI
#define M_PI	3.14159265358979323846
#endif

#ifndef	SIMPLE_CONVOLUTION
typedef struct {
		double	re,im;
	} Complex;

typedef struct {
		int	N,L,M;
		double	delta,r0delta,R2,theta0,M_PIM,*Cos,*Sin;
		Float	**pq;
		Complex	*G,*Z,*E;
	} CBP;
#else
typedef struct {
		int	N,M;
		double	delta,r0delta,R2,theta0,M_PIM,*g,*z,*Cos,*Sin;
		Float	**pq;
	} CBP;
#endif

extern CBP	*SetUpCBP     (/* int N,	*/
			       /* int M,	*/
			       /* double delta,	*/
			       /* double r0,	*/
			       /* double theta0	*/);
extern void	Convolution   (/* CBP *cbp	*/),
		ClearCBP      (/* CBP *cbp,	*/
			       /* Float **f	*/);
extern double	Ramachandran  (/* double delta,	*/
			       /* int k		*/),
		Shepp         (/* double delta,	*/
			       /* int k		*/),
		Chesler       (/* double delta,	*/
			       /* int k		*/),
		BackProjection(/* CBP *cbp,	*/
			       /* double x,	*/
			       /* double y	*/);
extern Float	**BPImage     (/* CBP *cbp	*/);
extern int	ReGridingCP   (/* CBP *cbp	*/);
