
#ifndef	Float
#define Float	double
#endif

#ifndef Filter
#define Filter	Shepp
#else
extern double	Filter();
#endif

#ifndef	M_PI
#define M_PI	3.14159265358979323846
#endif

typedef struct {
		double	re,im;
	} Complex;

typedef struct {
		int	N,M;
		double	delta,theta0,M_PIM,*Cos,*Sin;
		Float	**pq;
		Complex	*Z,*E,*ABG;
	} FBP;

extern FBP	*SetUpFBP     (/* int N,	*/
			       /* int M,	*/
			       /* double delta,	*/
			       /* double r0,	*/
			       /* double theta0	*/);
extern void	Filtering     (/* FBP *fbp	*/),
		ClearFBP      (/* FBP *fbp,	*/
			       /* Float **f	*/);
extern double	Ramachandran  (/* double delta,	*/
			       /* double z	*/),
		Shepp         (/* double delta,	*/
			       /* double z	*/),
		Chesler       (/* double delta,	*/
			       /* double z	*/),
		BackProjection(/* FBP *fbp,	*/
			       /* double x,	*/
			       /* double y	*/);
extern Float	**BPImage     (/* FBP *fbp	*/);
extern int	ReGridingFP   (/* FBP *fbp	*/);
