
#include <stdio.h>
#include <stdlib.h>

static void	Error(msg)
char		*msg;
{
	fputs(msg,stderr); fputc('\n',stderr); exit(1);
}

#define LINE_LEN	512

int	main(argc,argv)
int	argc;
char	**argv;
{
	FILE	*file;
	char	line[LINE_LEN];
	int	Nx,Ny,x,y;
	double	data,min,max;

	if (argc!=2) Error("usage : a2mm binaryArray");

	if (argv[1][0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(argv[1],"rb"))==NULL) Error("file not found.");

	if (fgets(line,LINE_LEN,file)==NULL ||
	    sscanf(line,"%d %d",&Nx,&Ny)!=2) Error("bad array size.");

	printf("%d\t%d\n",Nx,Ny);

	for (y=0; y<Ny; y++) for (x=0; x<Nx; x++) {
	    if (fread(&data,sizeof(data),1,file)!=1) Error("data read error.");

	    if (x==0 && y==0)
		min=max=data;
	    else
		if (data<min) min=data; else if (data>max) max=data;
	}
	if (file!=stdin) fclose(file);

	printf("%lf\t%lf\n",min,max); return 0;
}
