
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "cell.h"
#include "rif.h"
#include "sif.h"

static void	Error(msg)
char		*msg;
{
	fputs(msg,stderr); fputc('\n',stderr); exit(1);
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	double	f0o,dfo,f0n,dfn,base,step;
	int	BPS,limit,Nx,Ny,x,y,value;
	Cell	**cell;
	char	*desc;

	if (argc!=8)
Error("usage : convpv old_TIFF old_f0 old_df new_f0 new_df BPS new_TIFF");

	f0o=atof(argv[2]);
	dfo=atof(argv[3]);
	f0n=atof(argv[4]);

	if ((dfn=atof(argv[5]))==0.0) Error("bad new_df.");

	if ((BPS=atoi(argv[6]))<=0 || BPS>8*sizeof(Cell)) Error("bad BPS.");

	ReadImageFile(argv[1],&Nx,&Ny,NULL,&cell,&desc);

	base=(f0o-f0n)/dfn+0.5; step=dfo/dfn; limit=(1<<BPS)-1;

	for (x=0; x<Nx; x++)
	for (y=0; y<Ny; y++)
	    if ((value=(int)floor(base+step*(double)cell[y][x]))<0)
		cell[y][x]=0;
	    else
		cell[y][x]=(value>limit)?(Cell)limit:(Cell)value;

	StoreImageFile(argv[7],Nx,Ny,BPS,cell,desc);

	return 0;
}
