
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "cell.h"
#include "rif.h"

static void	Error(msg)
char		*msg;
{
	fputs(msg,stderr); fputc('\n',stderr); exit(1);
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	double	f1,f2,f0n,dfn,f0o,dfo,base,step;
	int	z0,Nz,*count,Nx,Ny,x,y,z;
	char	path[256];
	Cell	**cell;

	if (argc!=5) Error("usage : counthg f1 f2 f0_new df_new");

	if ((f1=atof(argv[1]))>=(f2=atof(argv[2])))
	    Error("bad lower and/or upper limit.");

	f0n=atof(argv[3]);
	if ((dfn=atof(argv[4]))==0.0) Error("bad new step.");

	if (dfn>0.0) {
	    z0=(int)floor((f1-f0n)/dfn+0.5); 
	    Nz=(int)floor((f2-f0n)/dfn+0.5)-z0+1;
	}
	else {
	    z0=(int)floor((f2-f0n)/dfn+0.5); 
	    Nz=(int)floor((f1-f0n)/dfn+0.5)-z0+1;
	}

	if ((count=(int *)calloc(Nz+1,sizeof(*count)))==NULL)
	    Error("memory allocation error.");

	while (scanf("%s %lf %lf",path,&f0o,&dfo)==3) {
	    ReadImageFile(path,&Nx,&Ny,NULL,&cell,NULL);
	    base=(f0o-f0n)/dfn+0.5; step=dfo/dfn;
	    for (y=0; y<Ny; y++) {
		for (x=0; x<Nx; x++) {
		    z=(int)floor(base+step*(double)cell[y][x])-z0;
		    if (z<0) z=0; else if (z>=Nz) z=Nz-1;
		    ++(count[z]);
		}
		free(cell[y]);
	    }
	    free(cell);
	}
	for (z=0; z<=Nz; z++)
	    printf("%lf\t%d\n",f0n+dfn*((double)(z+z0)-0.5),count[z]);

	return 0;
}
