
#include <stdio.h>
#include <stdlib.h>

static void	Error(msg)
char		*msg;
{
	fputs(msg,stderr); fputc('\n',stderr); exit(1);
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	detectors,N,M,N1,N2,N3,n,m;
	FILE	*file;
	double	dr,r0,t0,p;

	if (argc!=2 && argc!=3) Error("usage : dar detectors {XP}");

	detectors=atoi(argv[1]);

	if (argc==2)
	    file=stdin;
	else
	    if ((file=fopen(argv[2],"r"))==NULL)
		Error("X-ray projection data file not found.");

	fscanf(file,"%d %lf %lf %d %lf",&N,&dr,&r0,&M,&t0);
	if (N<=0 || dr<=0.0 || M<=0) Error("bad X-ray CT scanner parameter.");

	if (detectors<0) {
	    if ((N1=N+detectors)<=0) Error("too many removal detectors.");

	    N2=N3=N;
	}
	else {
	    N1=N2=N; N3=N+detectors;
	}
	printf("%d\t%lf\t%lf\n%d\t%lf\n",N+detectors,dr,r0,M,t0);

	for (m=0; m<M; m++) {
	    for (n=0; n<N1; n++) {
		fscanf(file,"%lf",&p); printf("%lf\n",p);
	    }
	    for (n=N1; n<N2; n++) fscanf(file,"%lf",&p);
	    for (n=N2; n<N3; n++) puts("0");
	}
	if (file!=stdin) fclose(file);

	return 0;
}
