
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "cell.h"
#include "rif.h"

static void	Error(msg)
char		*msg;
{
	fputs(msg,stderr); fputc('\n',stderr); exit(1);
}

static int	Nx1,Ny1,Nx2,Ny2;
static Cell	**cell1,**cell2;

static void	Difference(dx,dy)
int		dx,dy;
{
	int	x1,y1,x2,y2,Nx,Ny,x,y,pels=0;
	double	diff,sqrs=0.0;
	Cell	c1,c2;

	if (dx>=0) { x1=0; x2=dx; } else { x1=(-dx); x2=0; }
	if (dy>=0) { y1=0; y2=dy; } else { y1=(-dy); y2=0; }

	Nx=Nx1-x1; x=Nx2-x2; if (Nx>x) Nx=x;
	Ny=Ny1-y1; y=Ny2-y2; if (Ny>y) Ny=y;

	for (y=0; y<Ny; y++)
	for (x=0; x<Nx; x++)
	    if ((c1=cell1[y+y1][x+x1])!=0 &&
		(c2=cell2[y+y2][x+x2])!=0) {
		++pels; diff=(double)c1-(double)c2; sqrs+=(diff*diff);
	    }

	if (pels) printf("%d\t%d\t%lf\n",dx,dy,sqrt(sqrs/(double)pels));
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	dx,dy,dx1,dy1,dx2,dy2;

	if (argc!=3 && argc!=7)
	    Error("usage : dti TIFF1 TIFF2 {dx1 dy1 dx2 dy2}");

	ReadImageFile(argv[1],&Nx1,&Ny1,NULL,&cell1,NULL);
	ReadImageFile(argv[2],&Nx2,&Ny2,NULL,&cell2,NULL);

	if (argc==3)
	    while (scanf("%d %d",&dx,&dy)==2) {
		if (dx<=(-Nx1) || dx>=Nx2 ||
		    dy<=(-Ny1) || dy>=Ny2) Error("bad distance");

		Difference(dx,dy);
	    }
	else {
	    if ((dx1=atoi(argv[3]))>
		(dx2=atoi(argv[5])) || dx1<=(-Nx1) || dx2>=Nx2 ||
		(dy1=atoi(argv[4]))>
		(dy2=atoi(argv[6])) || dy1<=(-Ny1) || dy2>=Ny2)
		Error("bad range of distance.");

	    for (dy=dy1; dy<=dy2; dy++)
	    for (dx=dx1; dx<=dx2; dx++) Difference(dx,dy);
	}
	return 0;
}
