
#include <stdio.h>
#include <stdlib.h>

static void	Error(msg)
char		*msg;
{
	fputs(msg,stderr); fputc('\n',stderr); exit(1);
}

static FILE	*hp;

#define Get1()	fgetc(hp)

static int	Get2()
{
	int	lo,hi;

	return ((lo=Get1())==EOF || (hi=Get1())==EOF)?-1:(hi<<8)|lo;
}

static int	GetCell()
{
	int	cell=Get2();

	if (cell<0) Error("unexpected end of file."); return cell;
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	len,Nx,Ny,x1,x2,y,x,*cell;

	if (argc!=3 && argc!=5) Error("usage : hp2line HiPic {x1 x2} y");

	if ((hp=fopen(argv[1],"rb"))==NULL) Error("file not found.");

	if (Get1()!='I' || Get1()!='M') Error("bad magic number.");

	if ((len=Get2())<0) Error("bad comment length.");

	if ((Nx=Get2())<=0 ||
	    (Ny=Get2())<=0) Error("bad image size.");

	if (argc==3) {
	    x1=0; x2=Nx-1;
	}
	else
	    if ((x1=atoi(argv[2]))<0 || x1>=Nx ||
		(x2=atoi(argv[3]))<0 || x2>=Nx)
		Error("bad line terminal points.");

	if ((y=atoi(argv[argc-1]))<0 || y>=Ny) Error("bad line position.");

	fseek(hp,(long)(12-8),1);	/* image offset */

	if (Get2()!=2) Error("bad image type.");

	fseek(hp,(long)(64+len-14),1);	/* reserved data and comment */

	if (x1<=x2) {
	    fseek(hp,((long)Nx*(long)y+(long)x1)*2L,1);
	    for (x=x1; x<=x2; x++) printf("%d\n",GetCell());
	}
	else {
	    if ((cell=(int *)calloc(Nx,sizeof(*cell)))==NULL)
		Error("line memory allocation error.");

	    fseek(hp,((long)Nx*(long)y+(long)x2)*2L,1);
	    for (x=x2; x<=x1; x++) cell[x]=GetCell();
	    for (x=x1; x>=x2; x--) printf("%d\n",cell[x]);

	    free(cell);
	}
	fclose(hp); return 0;
}
