
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

static void	Error(msg)
char		*msg;
{
	fputs(msg,stderr); fputc('\n',stderr); exit(1);
}

static FILE	*hp;

#define Get1()	fgetc(hp)

static int	Get2()
{
	int	lo,hi;

	return ((lo=Get1())==EOF || (hi=Get1())==EOF)?-1:(hi<<8)|lo;
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	int		len,idx,code,comma=0;
	char		*str,*ptr;
	struct tm	tm;

	if (argc!=1 && argc!=2) Error("usage : hp2time {HiPic}");

	if (argc==1)
	    hp=stdin;
	else
	    if ((hp=fopen(argv[1],"rb"))==NULL) Error("file not found.");

	if (Get1()!='I' || Get1()!='M') Error("bad magic number.");

	if ((len=Get2())<=0) Error("bad comment length.");

	for (idx=4; idx<64; idx++) (void)Get1();	/* image size,
							   image offset,
							   image type and
							   reserved data */

	for (idx=0; idx<len; idx++) if (Get1()==',' && ++comma==11) break;

	if (comma!=11) Error("top of imaging time not found.");

	if ((str=ptr=(char *)malloc(len-idx+1))==NULL)
	    Error("imaging time string memory allocation error.");

	while (++idx<len) {
	    if ((code=Get1())==',')
		if (++comma==13)
		    break;
		else
		    code='\t';
	    else
		if (code=='-' || code==':') code='\t';

	    *(ptr++)=code;
	}
	*ptr='\0';

	if (comma!=13) Error("end of imaging time not found.");

	if (hp!=stdin) fclose(hp);

	puts(str);

	if (sscanf(str,"%d %d %d %d %d %d",&(tm.tm_year),
					   &(tm.tm_mon ),
					   &(tm.tm_mday),
					   &(tm.tm_hour),
					   &(tm.tm_min ),
					   &(tm.tm_sec ))==6) {
	    tm.tm_year-=1900; tm.tm_mon-=1;

	    printf("%ld\n",(long)mktime(&tm));
	}
	else
	    puts("0");

	return 0;
}
