
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"

#ifndef CUE_RATIO
#define CUE_RATIO	4.4
#endif

#define MA(cnt,ptr)	malloc((cnt)*sizeof(*(ptr)))

char	**AllocateFlagMemory(Nx,Ny)
int	Nx,Ny;
{
	char	**flag;
        int	x,y;

	if ((flag=(char **)MA(Ny,flag))==NULL) return NULL;

	for (y=0; y<Ny; y++) {
	    if ((flag[y]=(char *)MA(Nx,*flag))==NULL) return NULL;

	    for (x=0; x<Nx; x++) flag[y][x]=0;
	}
	return flag;
}

typedef struct {
		int	x,y;
	} Cue;

static int	Len,Cnt;
static Cue	*Top,*End,*Head;

#define ERROR(msg)	{ fputs(msg,stderr); fputc('n',stderr); exit(1); }

static void	PushCue(x,y)
int		x,y;
{
	if (++Cnt>Len) ERROR("cue overflow.");

	Head->x=x; Head->y=y; if (++Head==End) Head=Top;
}

#define OCCUPIED(x,y)	(x>=0 && x<Nx && y>=0 && y<Ny && flag[y][x]==1)

static void	PaintBackground(Nx,Ny,flag,x,y)
int		Nx,Ny,x,y;
char		**flag;
{
	Cue	*tail;
	int	yP,yM,S,N,dx,S0,N0,x0,x1,S1,N1;

	Head=tail=Top;
	for (Cnt=0; Cnt>=0; Cnt--) {
	    if (OCCUPIED(x,y)) {
		flag[y][x]=0; yP=y+1; S=OCCUPIED(x,yP);
			      yM=y-1; N=OCCUPIED(x,yM);
		for (dx=1; dx>=(-1); dx-=2) {
		    S0=S; N0=N;
		    for (x1=x, x0=x+dx; OCCUPIED(x0,y); x1=x0, x0+=dx) {
			flag[y][x0]=0; S1=S0; S0=OCCUPIED(x0,yP);
				       N1=N0; N0=OCCUPIED(x0,yM);
			if (S1 && !S0) PushCue(x1,yP);
			if (N1 && !N0) PushCue(x1,yM);
		    }
		    if (S0) PushCue(x1,yP);
		    if (N0) PushCue(x1,yM);
		}
	    }
	    x=tail->x; y=tail->y; if (++tail==End) tail=Top;
	}
}

#define PAINT(x,y)	if (flag[y][x]==1) PaintBackground(Nx,Ny,flag,x,y)

char	**PareObjectSkin(Nx,Ny,cell,background,threshold,thickness)
int	Nx,Ny,background,threshold,thickness;
Cell	**cell;
{
	char	**flag=AllocateFlagMemory(Nx,Ny);
	int	x,y,t,h=Nx-1,v=Ny-1;

	if (flag==NULL) ERROR("flag memory allocation error.");

	if (background) {
	    Len=(int)(CUE_RATIO*(double)(Nx+Ny)+1.0);
	    if ((Top=(Cue *)MA(Len,Top))==NULL)
		ERROR("cue memory allocation error.");

	    End=(&(Top[Len]));

	    for (x=0; x<Nx; x++)
	    for (y=0; y<Ny; y++) flag[y][x]=((int)cell[y][x]<threshold)?1:2;

	    for (x=0; x<Nx; x++) { PAINT(x,0); PAINT(x,v); }
	    for (y=0; y<Ny; y++) { PAINT(0,y); PAINT(h,y); }

	    for (x=0; x<Nx; x++)
	    for (y=0; y<Ny; y++) if (flag[y][x]==2) flag[y][x]=1;

	    free(Top);
	}
	else
	    for (y=0; y<Ny; y++)
	    for (x=0; x<Nx; x++) flag[y][x]=((int)cell[y][x]<threshold)?0:1;

	for (t=0; t<thickness; t++, h--, v--) {
	    for (x=t; x<=h; x++)
	    for (y=t; y<=v; y++)
		if (flag[y][x])
		    if (x==t || !flag[y][x-1] ||
			x==h || !flag[y][x+1] ||
			y==t || !flag[y-1][x] ||
			y==v || !flag[y+1][x]) flag[y][x]|=2;

	    for (x=t; x<=h; x++)
	    for (y=t; y<=v; y++) if (flag[y][x]&2) flag[y][x]=0;
	}
	return flag;
}
