
#include <stdio.h>
#include <stdlib.h>
#include "CBP.h"

static void	Error(msg)
char		*msg;
{
	fputs(msg,stderr); fputc('\n',stderr); exit(1);
}

#define LINE_LEN	512
#define RADIAN		0.01745329251994329576

int	main(argc,argv)
int	argc;
char	**argv;
{
	FILE	*file;
	char	line[LINE_LEN];
	int	N,M,n,m,x,y;
	double	dr,r0,t0,qf;
	CBP	*cbp;
	Float	**f;

	if (argc!=6)
	    Error("usage : q2f filteredProjection_q dr r0/dr t0 LAC_f");

	if (argv[1][0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(argv[1],"rb"))==NULL)
		Error("filterd projection (q) data file not found.");

	if (fgets(line,LINE_LEN,file)==NULL ||
	    sscanf(line,"%d %d",&N,&M)!=2 ||
	    N<=0 || M<=0) Error("bad number of filtered projections.");

	if ((dr=atof(argv[2]))<=0.0) Error("bad dr.");

	r0=atof(argv[3])*dr;
	t0=atof(argv[4]);

	if ((cbp=SetUpCBP(N,M,dr,r0,t0*RADIAN))==NULL)
	    Error("SetUpCBP() memory allocation error.");

	for (m=0; m<M; m++) for (n=0; n<N; n++) {
	    fread(&qf,sizeof(qf),1,file); cbp->pq[m][n]=qf;
	}
	if (file!=stdin) fclose(file);

	if (!ReGridingCP(cbp)) Error("ReGridingCP() memory allocation error.");

	if ((f=BPImage(cbp))==NULL) Error("BPImage() memory allocation error.");

	if (argv[5][0]=='-')
	    file=stdout;
	else
	    if ((file=fopen(argv[5],"wb"))==NULL)
		Error("CT value (f) data file not stored.");

	fprintf(file,"%d\t%d\n",N,N);

	for (y=0; y<N; y++) for (x=0; x<N; x++) {
	    qf=f[y][x]; fwrite(&qf,sizeof(qf),1,file);
	}
	if (file!=stdin) fclose(file);

	return 0;
}
