
#include <stdio.h>
#include <stdlib.h>

static void	Error(msg)
char		*msg;
{
	fputs(msg,stderr); fputc('\n',stderr); exit(1);
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	double	dr,r0,theta0,p,LAC=1.0;
	int	N,M,m,n;
	FILE	*file;

	if (argc!=2 && argc!=3) Error("usage : t2p {LAC} XP");

	if (argc==3) LAC=atof(argv[1]);

	if (scanf("%d %lf %lf %d %lf",&N,&dr,&r0,&M,&theta0)!=5)
	    Error("bad X-ray CT scanner parameter.");

	fprintf(stderr,"%d\t%lf\t%lf\n%d\t%lf\n",N,dr,r0/dr,M,theta0);

	if (argv[argc-1][0]=='-')
	    file=stdout;
	else
	    if ((file=fopen(argv[argc-1],"wb"))==NULL)
		Error("file not stored.");

	fprintf(file,"%d\t%d\n",N,M);

	for (m=0; m<M; m++) for (n=0; n<N; n++) {
	    if (scanf("%lf",&p)!=1) Error("data read error.");

	    p*=LAC; fwrite(&p,sizeof(p),1,file);
	}
	if (file!=stdout) fclose(file); return 0;
}
